zoukankan      html  css  js  c++  java
  • HDU 3032 Nim or not Nim? (sg函数求解)

    Nim or not Nim?


    Problem Description
    Nim is a two-player mathematic game of strategy in which players take turns removing objects from distinct heaps. On each turn, a player must remove at least one object, and may remove any number of objects provided they all come from the same heap.

    Nim is usually played as a misere game, in which the player to take the last object loses. Nim can also be played as a normal play game, which means that the person who makes the last move (i.e., who takes the last object) wins. This is called normal play because most games follow this convention, even though Nim usually does not.

    Alice and Bob is tired of playing Nim under the standard rule, so they make a difference by also allowing the player to separate one of the heaps into two smaller ones. That is, each turn the player may either remove any number of objects from a heap or separate a heap into two smaller ones, and the one who takes the last object wins.
     

    Input
    Input contains multiple test cases. The first line is an integer 1 ≤ T ≤ 100, the number of test cases. Each case begins with an integer N, indicating the number of the heaps, the next line contains N integers s[0], s[1], ...., s[N-1], representing heaps with s[0], s[1], ..., s[N-1] objects respectively.(1 ≤ N ≤ 10^6, 1 ≤ S[i] ≤ 2^31 - 1)
     

    Output
    For each test case, output a line which contains either "Alice" or "Bob", which is the winner of this game. Alice will play first. You may asume they never make mistakes.
     

    Sample Input
    2 3 2 2 3 2 3 3
     

    Sample Output
    Alice Bob
     

    Source
     


    题目大意:

    Alice和Bob轮流取N堆石子,每堆S[i]个,Alice先。每一次能够从随意一堆中拿走随意个石子,也能够将一堆石子分为两个小堆。先拿完者获胜。

    (1 ≤ N ≤ 10^6, 1 ≤ S[i] ≤ 2^31 - 1)


    解题思路:

    对于一个给定的有向无环图。定义关于图的每一个顶点的Sprague-Grundy函数g例如以下:g(x)=mex{ g(y) | y是x的后继 },这里的g(x)即sg[x]
    比如:取石子问题,有1堆n个的石子,每次仅仅能取{1。3,4}个石子。先取完石子者胜利。那么各个数的SG值为多少?
    sg[0]=0,
    n=1时,能够取走{1}个石子,剩余{0}个。mex{sg[0]}={0}。故sg[1]=1;
    n=2时,能够取走{1}个石子。剩余{1}个,mex{sg[1]}={1}。故sg[2]=0;
    n=3时。能够取走{1,3}个石子,剩余{2,0}个。mex{sg[2],sg[0]}={0,0},故sg[3]=1;
    n=4时,能够取走{1,3,4}个石子。剩余{3,1,0}个,mex{sg[3],sg[1],sg[0]}={1,1,0},故sg[4]=2;
    n=5时。能够取走{1,3,4}个石子。剩余{4,2,1}个,mex{sg[4],sg[2],sg[1]}={2,0,1},故sg[5]=3;
    以此类推.....
         x  0  1  2  3  4  5  6  7  8....
    sg[x] 0  1  0  1  2  3  2  0  1....

    所以,对于这题:

    sg[0]=0

    sg[1]=mex{sg[0] }=1

    sg[2]=mex{sg[0],sg[1],sg[1,1] }=mex{0,1,1^1}=2;

    sg[3]=mex{sg[0],sg[1],sg[2],sg[1,2]}=mex{0,1,2,1^2}=mex{0,1,2,3}=4;

    sg[4]=mex{sg[0],sg[1],sg[2],sg[3],sg[1,3],sg[2,2]}=mex{0,1,2,4,5,0}=3;

                  ..............................................................................

    能够发现:sg[4*k+1]=4*k+1,sg[4*k+2]=4*k+2,  sg[4*k+3]=4*k+4,sg[4*k+4]=4*k+3


    解题代码:


    #include <iostream>
    using namespace std;
    
    int main(){
        int t;
        cin>>t;
        while(t-- >0){
            int sg=0,n,x;
            cin>>n;
            for(int i=0;i<n;i++){
                cin>>x;
                if(x%4==0) sg^=x-1;
                else if(x%4==3) sg^=x+1;
                else sg^=x;
            }
            if(sg) cout<<"Alice"<<endl;
            else cout<<"Bob"<<endl;
        }
        return 0;
    }
    




     

    版权声明:本文博主原创文章。博客,未经同意不得转载。

  • 相关阅读:
    醒醒吧少年,只用Cucumber不能帮助你BDD
    【Python3 爬虫】06_robots.txt查看网站爬取限制情况
    【Python3 爬虫】05_安装Scrapy
    【基尼系数】基尼系数的计算方法与计算案例
    【Python3 爬虫】04_urllib.request.urlretrieve
    【Python3 爬虫】03_urllib.error异常处理
    【Python3 爬虫】02_利用urllib.urlopen向百度翻译发送数据并返回结果
    【Python】help与dir的用法
    在线激活Pycharm(亲测有效)
    【Python3 爬虫】01_简单页面抓取
  • 原文地址:https://www.cnblogs.com/hrhguanli/p/4797041.html
Copyright © 2011-2022 走看看